<template>
    <div>
        <!-- <label for="name" class="block text-sm font-medium text-gray-600" :class="{'required': required}">{{ label }}</label> -->
        <div class="mt-1 relative rounded-md shadow-sm">
            <textarea @keypress="numberOnly" @blur="$emit('blur')" v-model="content" type="text" name="email" class="text-lg resize-y h-44 py-4 font-mont block w-full pr-10 border border-xmas-gray focus:outline-none focus:ring-0 focus:border-none focus:border-xmas-olive sm:text-sm" :class="conditionalClasses" :placeholder='label'></textarea>
            <div v-if='invalid' class="absolute inset-y-0 right-0 pr-3 flex items-center pointer-events-none">
                <ExclamationCircleIcon class="h-5 w-5 text-red-500" aria-hidden="true" />
            </div>
        </div>
        <p v-if='description' class="mt-2 text-xs text-gray-500" id="email-description">{{ description }}</p>
    </div>
</template>

<script>
import { ExclamationCircleIcon } from '@heroicons/vue/solid'

export default {
    props: {
        modelValue: null,
        label: String,
        invalid: Boolean,
        description: String,
        number: Boolean,
        required: Boolean
    },
    components: {
        ExclamationCircleIcon
    },
    data() {
        return {
            content: this.modelValue
        }
    },    
    methods: {
        numberOnly(event) {
            if(this.number) {
                let keyCode = (event.keyCode ? event.keyCode : event.which);
                if ((keyCode < 48 || keyCode > 57) && keyCode !== 46) { // 46 is dot
                    event.preventDefault();
                }
            }
        }
    },
    watch: {
        content(value) {
            this.$emit('update:modelValue', value)
        }
    },
    computed: {
        conditionalClasses() {
            return {
                'border-red-500 text-red-500 focus:ring-red-700 focus:border-red-700': this.invalid
            }
        }
    }

}
</script>

<style lang="sass">
.required
    &::after
        content: '*'
        color: #b20000
        margin-left: 4px
    
</style>